CsvTest fails due to a regression in Ruby 2.5
Description
Ruby 2.5.0 at r17185 don't pass csv_test.rb:29.

Failure:

CsvTest#test_should_include_bom_when_utf8_encoded [/Users/sho-h/local/src/redmine/redmine.sho-h/te
st/unit/lib/redmine/export/csv_test.rb:29]:

Expected false to be truthy.

Maybe, the reason is regression in 2.5.0.
$ cat csvtest.rb
require 'csv'

bom = "\xEF\xBB\xBF"
resl_1 = bom.dup

resl_2 CSV.generate (resl_1, encoding: "UTF-8") {|csv]| csv << %w(Foo Bar)}

p [bom, resl_1, resl_2]

res2_1 = "aa,bb"
res2_2 = CSV.generate(res2_1, encoding: "UTF-8") {|csv| csv << %w(Foo Bar)}
p [bom, res2_1, res2_2]

$ rbenv each ruby -v csvtest.rb | more

ruby 2.3.6p384 (2017-12-14 revision 61254) [x86_64-darwinl5]
["<U+FEFF>", "<U+FEFF>Foo,Bar\n", "<U+FEFF>Foo,Bar\n"]
["<U+FEFF>", "aa,bbFoo,Bar\n", "aa,bbFoo,Bar\n"]

ruby 2.4.3p205 (2017-12-14 revision 61247) [x86_64-darwinl5]
["<U+FEFF>", "<U+FEFF>Foo0,Bar\n", "<U+FEFF>Foo,Bar\n"]
["<U+FEFEF>", "aa,bbFoo,Bar\n", "aa,bbFoo,Bar\n"]

ruby 2.5.0p0 (2017-12-25 revision 61468) [x86_64-darwinl5]
["<U+FEFF>", "Foo,Bar\n", "Foo,Bar\n"]

["<U+FEFF>", "Foo,Bar\n", "Foo,Bar\n"]

This problem was already reported below.

e https://github.com/ruby/csv/pull/13

| attach patch to fix this problem. This patch don't use CSV.generate's first argument.

Related issues:
Related to Redmine - Defect #28689: csv 1.0.2 gem breaks ImportsControllerTest Closed
Blocks Redmine - Feature #27849: Ruby 2.5 support Closed

Associated revisions

Revision 17245 - 2018-03-29 15:49 - Go MAEDA

CsvTest#test_should_include_bom_when_utf8_encoded fails due to a regression in Ruby 2.5.0 (#28112).

Contributed by Sho HASHIMOTO.

Revision 17696 - 2018-12-08 06:51 - Go MAEDA
Don't explicitly install csv gem in Ruby 2.6 (#30118).
https://www.redmine.org/projects/redmine/repository/svn/revisions/17185
https://github.com/ruby/csv/pull/13

Redmine installs csv gem since r17245 as a workaround for a bug of csv 1.0.0 which is bundled with Ruby 2.5 (see #28112). But in Ruby 2.6,

installing the gem is not necessary because the bundled csv gem was updated to 3.0.

History

#1 - 2018-01-31 14:17 - Go MAEDA
- Blocks Feature #27849: Ruby 2.5 support added

#2 - 2018-03-24 02:06 - Sho HASHIMOTO
Above problem fixed by csv gem 1.0.1.

#3 - 2018-03-26 16:49 - Go MAEDA
Sho HASHIMOTO wrote:

Above problem fixed by csv gem 1.0.1.

Thank you for looking into this issue. Do you think we can fix this issue by changing Gemfile as follows?

Index: Gemfile

——— Gemfile (revision 17236)
+++ Gemfile (working copy)
@@ -13,6 +13,7 Qe

gem "roadie", "~> 3.2.1"

gem "mimemagic"
gem "mail", "~> 2.6.4"
+gem "csv", "~> 1.0.1" if RUBY_VERSION >= "2.5"

gem "nokogiri", "~> 1.8.0"
gem "il8n", "~> 0.7.0"

#4 - 2018-03-27 03:26 - Sho HASHIMOTO

Thank you for looking into this issue. Do you think we can fix this issue by changing Gemfile as follows?

| think so. My patch is not needed any more. :)
| checked unit test only appending below line to Gemfile.local. My Ruby was 2.5.0.

gem 'csv', '1.0.1'

#5 - 2018-03-29 15:51 - Go MAEDA
- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the fix. Thank you for working on this issue.

#6 - 2018-05-06 02:11 - Go MAEDA
- Related to Defect #28689: csv 1.0.2 gem breaks ImportsControllerTest added

#7 - 2018-12-08 05:17 - Go MAEDA

- Subject changed from Ruby 2.5.0 don't pass csv_test.rb to CsvTest fails due to a regression in Ruby 2.5

Files

redmine_with_ruby250.patch 954 Bytes 2018-01-31

2025-05-17

Sho HASHIMOTO

22


http://www.tcpdf.org

